/*******************************************************************************
* 
* The content of this file or document is CONFIDENTIAL and PROPRIETARY
* to Mobilygen Corporation.  It is subject to the terms of a
* License Agreement between Licensee and Mobilygen Corporation.
* restricting among other things, the use, reproduction, distribution
* and transfer.  Each of the embodiments, including this information and
* any derivative work shall retain this copyright notice.
* 
* Copyright 2004 Mobilygen Corporation.
* All rights reserved.
* 
* QuArc is a registered trademark of Mobilygen Corporation.
* 
*******************************************************************************/

#ifndef __QMMLOADER_H
#define __QMMLOADER_H

/* Maximum number of codecs supported byy qmmloader */
#define QMMLOADER_MAX_CODECS	32

#define SYSDATA_FREQMULT	0	/* RTC frequency divided in kHz by SYSDATA_FREQDIV */
#define SYSDATA_FREQDIV		1	/* see SYSDATA_FREQMULT */
#define SYSDATA_QMMMEMSIZE	2	/* Total memory size usable by QMM */
#define SYSDATA_MEMSIZE		3	/* Total memory size usable by the Codec */
#define SYSDATA_BOOTTIME	4	/* Start time for the RTC */
#define SYSDATA_DEBUGMODE	8	/* Debug mode */
#define SYSDATA_CLK1		11	/* Clock (codec dependent) */
#define SYSDATA_CLK2		12	/* Clock (codec dependent) */
#define SYSDATA_CLK3		13	/* Clock (codec dependent) */
#define SYSDATA_CLK4		14	/* Clock (codec dependent) */
#define SYSDATA_CLK5		15	/* Clock (codec dependent) */
/* fields 16 to 31 are application dependent */
#define SYSDATA_NFIELDS		32	/* Number of System data entries */

extern int qmmldLoadAndRun(int codec, char *buffer, int size);
extern int qmmldLoadAndRunFile(int codec, char *filename);
extern int qmmldLoadCSROnly(int codec, char *buffer, int size);
extern int qmmldLoadCSROnlyFile(int codec, char *filename);
extern int qmmldLoadSectionOnly(int codec, char *buffer, int size, int sectionAddr);
extern int qmmldLoadSectionOnlyFile(int codec, char *filename, int sectionAddr);
extern unsigned long qmmldGetGPB(int codec);
extern int qmmldGetQMMPartID(int codec);
extern int qmmldSetVerbosity(int level);
extern int qmmldSoftReset(int codec);
/**qmmldSetSystemData
 * Set one field of the system data. Must be called before qmmLoadAndRun
 */
extern int qmmldSetSystemData(int index, unsigned int val);
/**qmmldSetSysConfig
 * Set the system config params
 */
extern int qmmldSetSysConfig(int *params, int nparams);
    
#endif  /* __QMMLOADER_H */

