-- This configuration has 2 video inputs each of which is encoded -- at IBBRBP AVC (high quality), IP (low quality), and MJPEG.

-- 2 D1 + 2 derived D1 15 fps + 1 MJPEG (currently 30 fps)
ENCCH = 2;
DECCH = 2;
ENCCH_2 = 2;
MJPEGCH = 1;

-- Output, either 480i/svideo or 1080i/hdmi or 1080i/component
FORMAT = "1080i";
VOUT = "hdmi";
PREVIEW = 1;
if(PREVIEW == 1) then 
	LVPP_LIVE_PREVIEW_TIME_DELAY = -3003;
	BURNIN_TIMECODE = 0;
end

-- streaming
HOST = HOST or "192.168.40.102";
SERVER = "NULL";

-- Streaming protocol 0 for nothing, 1 for UDP, 2 for RTP
STREAMING_ENCCH     = STREAMING_ENCCH or 2;
STREAMING_ENCCH_2   = STREAMING_ENCCH_2 or 2;
STREAMING_MJPEGCH  = STREAMING_MJPEGCH or 2;

ENCCH_TO_STREAM = 2;
ENCCH_2_TO_STREAM = 2;
MJPEGCH_TO_STREAM = 1;

ENCCH_TO_STORE = 0;
ENCCH_2_TO_STORE = 0;
MJPEGCH_TO_STORE = 0;

--[[
-- single cloned input settings
--VIN = "svideo";
--INPUTFORMAT = "480i";
--MAIN_CAPTURE_FRAMES = 10;
--RENDER_BFF = 1;
--]]

-- set to use 8 references and a reasonable avsn skew
NUM_AVC_REFERENCES = 8;
AVC_RECON_PREVIEW_TIME_DELAY = -12012;

ENCW_2 = 720;
ENCH_2 = 480;

MAIN_GOP_STRUCTURE = "IBBRBP";
MAIN_FRAME_STRUCTURE = "mbaff";
MAIN_CLOSED_GOP = 1;

SECONDARY_GOP_STRUCTURE = "IP";
SECONDARY_FRAME_STRUCTURE = "mbaff";
SECONDARY_CLOSED_GOP = 1;

SECONDARY_TF_Y_BYPASS = 0;
SECONDARY_PME_ENABLE = 1;
SECONDARY_PME_FRAME_MODE = 0;
SECONDARY_PME_W = 2;
SECONDARY_PME_H = 4;
SECONDARY_STC_PER_FRAME = 3003;
SECONDARY_STC_PER_OUTPUT_FRAME = 6006;
SECONDARY_SINGLE_FIELD_DOWNSCALE = 0;
SECONDARY_NVPP_INTERLACED = 1;

BITRATE = {};
BITRATE[1] = 1500000;
BITRATE[2] = 1500000;
BITRATE[3] = 1500000;
BITRATE[4] = 1500000;

BITRATE_2 = {};
BITRATE_2[1] = 500000;
BITRATE_2[2] = 500000;
BITRATE_2[3] = 500000;
BITRATE_2[4] = 500000;

BITRATE_MJPEG = {};
BITRATE_MJPEG[1] = 2000000;
BITRATE_MJPEG[2] = 2000000;
BITRATE_MJPEG[3] = 2000000;
BITRATE_MJPEG[4] = 2000000;

MAIN_ENC_BUFFER_SIZE = 1000000;
SECONDARY_ENC_BUFFER_SIZE = 1000000;

MAIN_ENC_GUARD_BAND = 200;
SECONDARY_ENC_GUARD_BAND = 200;
JPEG_ENC_GUARD_BAND = 300;

MAX_LVPP_USED = 2;

-- We need to set these to 0 for VLC 0.8.6h compatibility
MAIN_IP_FIELD_CODING = 0;
SECONDARY_IP_FIELD_CODING = 0;

-- Set the display for two D1s
OUTGRIDW = 2;
OUTGRIDH = 1; -- change to 2 for 2x2 display which can show live + reconstructed

-- Tweak the display of 480i on 1080i to use integer scaling
if ((FORMAT == "1080i") and (OUTGRIDH == 1)) then
  DISPLAYWIDTH = 1440;
  DISPLAYHEIGHT = 960;
  DISPLAYOFFSET_X = 240;
  DISPLAYOFFSET_Y = 60;
  COMP_PIXEL_AR_X = 1;
  COMP_PIXEL_AR_Y = 1;
end


function play(i)
    if (PREVIEW == 2) then
      hiderecon(i);
    end
    hidelive(i);
    showplayback(i);
    if (DECCH == 1) then
        startplayback(i,1);
    elseif (DECCH > 1) then
    	startplayback(i,i);
    end
end
